package org.jboss.cache;

import org.jboss.cache.factories.annotations.Inject;
import org.jboss.cache.lock.LockStrategyFactory;

import java.util.Map;

/**
 * Node factory specific to pessimistic locking.
 *
 * @author Manik Surtani (<a href="mailto:manik@jboss.org">manik@jboss.org</a>)
 * @since 3.0
 * @deprecated will be removed along with optimistic and pessimistic locking.
 */
@Deprecated
public class PessimisticNodeFactory<K, V> extends AbstractNodeFactory<K, V>
{
   private LockStrategyFactory lockStrategyFactory;

   @Inject
   private void injectLockStrategyFactory(LockStrategyFactory lockStrategyFactory)
   {
      this.lockStrategyFactory = lockStrategyFactory;
   }

   @Override
   protected UnversionedNode<K, V> createInternalNode(Object childName, Fqn fqn, NodeSPI<K, V> parent, Map<K, V> data)
   {
      PessimisticUnversionedNode<K, V> internal = new PessimisticUnversionedNode<K, V>(childName, fqn, data, cache);
      internal.injectDependencies(cache, commandsFactory, this);
      internal.injectLockStrategyFactory(lockStrategyFactory);
      return internal;
   }
}
