package org.jboss.cache.annotations;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * A marker annotation to mark that a class, method or field is experimental and as such.  Should never be used for any
 * new code.  Similar to deprecated, but provides additional meaning to developers on why certain classes exist.
 * <p/>
 *
 * @author Manik Surtani (<a href="mailto:manik@jboss.org">manik@jboss.org</a>)
 * @since 3.0
 */
@Retention(RetentionPolicy.SOURCE)
@Target({ElementType.TYPE, ElementType.CONSTRUCTOR, ElementType.FIELD, ElementType.LOCAL_VARIABLE,
      ElementType.METHOD, ElementType.PACKAGE, ElementType.PARAMETER})
public @interface Compat
{
   String notes() default "";
}