package org.jboss.cache.commands.legacy.write;

import org.jboss.cache.CacheException;
import org.jboss.cache.Fqn;
import org.jboss.cache.InvocationContext;
import org.jboss.cache.NodeSPI;
import org.jboss.cache.commands.legacy.ReversibleCommand;
import org.jboss.cache.commands.write.PutKeyValueCommand;
import org.jboss.cache.transaction.GlobalTransaction;

/**
 * A version of {@link org.jboss.cache.commands.write.PutKeyValueCommand} which can be rolled back, for use with
 * pessimistic locking where changes are made directly on the data structures and may need to be reversed.
 *
 * @author Manik Surtani (<a href="mailto:manik@jboss.org">manik@jboss.org</a>)
 * @since 3.0
 * @deprecated will be removed along with optimistic and pessimistic locking.
 */
@Deprecated
public class PessPutKeyValueCommand extends PutKeyValueCommand implements ReversibleCommand
{
   protected Object oldValue;

   public PessPutKeyValueCommand(GlobalTransaction gtx, Fqn fqn, Object key, Object value)
   {
      super(gtx, fqn, key, value);
   }

   public PessPutKeyValueCommand()
   {
   }

   @Override
   public Object perform(InvocationContext ctx)
   {
      oldValue = super.perform(ctx);
      return oldValue;
   }

   public void rollback()
   {
      NodeSPI n = dataContainer.peek(fqn, false, false);
      if (n == null) throw new CacheException("node " + fqn + " not found for rollback!");
      if (oldValue == null)
      {
         n.removeDirect(key);
      }
      else
      {
         n.putDirect(key, oldValue);
      }
   }
}
