package org.jboss.cache.commands.legacy.write;

import org.jboss.cache.Fqn;
import org.jboss.cache.InvocationContext;
import org.jboss.cache.NodeSPI;
import org.jboss.cache.commands.legacy.ReversibleCommand;
import org.jboss.cache.commands.write.RemoveKeyCommand;
import org.jboss.cache.transaction.GlobalTransaction;

/**
 * A version of {@link org.jboss.cache.commands.write.RemoveKeyCommand} which can be rolled back, for use with
 * pessimistic locking where changes are made directly on the data structures and may need to be reversed.
 *
 * @author Manik Surtani (<a href="mailto:manik@jboss.org">manik@jboss.org</a>)
 * @since 3.0
 * @deprecated will be removed along with optimistic and pessimistic locking.
 */
@Deprecated
public class PessRemoveKeyCommand extends RemoveKeyCommand implements ReversibleCommand
{
   /* internally used for rollback */
   private Object oldValue;

   public PessRemoveKeyCommand(GlobalTransaction gtx, Fqn fqn, Object key)
   {
      super(gtx, fqn, key);
   }

   public PessRemoveKeyCommand()
   {
   }

   @Override
   public Object perform(InvocationContext ctx)
   {
      oldValue = super.perform(ctx);
      return oldValue;
   }

   public void rollback()
   {
      if (oldValue != null)
      {
         NodeSPI targetNode = dataContainer.peek(fqn, false, true);
         if (targetNode != null) targetNode.putDirect(key, oldValue);
      }
   }
}
