/**
 *
 * @author Bela Ban Nov 25, 2003
 * @version $Id: IsolationLevel.java 6026 2008-06-25 13:21:22Z manik.surtani@jboss.com $
 */
package org.jboss.cache.lock;

/**
 * Various transaction isolation levels as an enumerated class.  Note that <a href="http://wiki.jboss.org/wiki/JBossCacheMVCC">MVCC</a>
 * in JBoss Cache 3.0.0 and above only supports {@link #READ_COMMITTED} and {@link #REPEATABLE_READ}, upgrading where possible.
 * <p/>
 * Also note that JBoss Cache defaults to {@link #REPEATABLE_READ}.
 * <p/>
 *
 * @see <a href="http://en.wikipedia.org/wiki/Isolation_%28computer_science%29">Isolation levels</a>
 */
public enum IsolationLevel
{
   /**
    * No isolation.
    */
   NONE,
   SERIALIZABLE,
   REPEATABLE_READ,
   READ_COMMITTED,
   READ_UNCOMMITTED
}
