package org.jboss.cache.optimistic;

import org.jboss.cache.AbstractNodeFactory;
import org.jboss.cache.Fqn;
import org.jboss.cache.NodeSPI;
import org.jboss.cache.UnversionedNode;
import org.jboss.cache.VersionedNode;
import org.jboss.cache.factories.annotations.Inject;
import org.jboss.cache.lock.LockStrategyFactory;

import java.util.Map;

/**
 * Node factory specific to optimistic locking.
 *
 * @author Manik Surtani (<a href="mailto:manik@jboss.org">manik@jboss.org</a>)
 * @since 3.0
 * @deprecated will be removed along with optimistic and pessimistic locking.
 */
@Deprecated
public class OptimisticNodeFactory<K, V> extends AbstractNodeFactory<K, V>
{
   private LockStrategyFactory lockStrategyFactory;

   @Inject
   private void injectLockStrategyFactory(LockStrategyFactory lockStrategyFactory)
   {
      this.lockStrategyFactory = lockStrategyFactory;
   }

   @Override
   protected UnversionedNode<K, V> createInternalNode(Object childName, Fqn fqn, NodeSPI<K, V> parent, Map<K, V> data)
   {
      VersionedNode<K, V> internal = new VersionedNode<K, V>(fqn, parent, data, cache);
      internal.injectDependencies(cache, commandsFactory, this);
      internal.injectLockStrategyFactory(lockStrategyFactory);
      return internal;
   }

   @Override
   public WorkspaceNode<K, V> createWrappedNode(NodeSPI<K, V> dataNode, TransactionWorkspace workspace)
   {
      return new WorkspaceNodeImpl<K, V>(dataNode, workspace, this);
   }
}
