package org.jboss.cache.lock;

import org.jboss.cache.Fqn;
import org.jboss.cache.config.Configuration;
import org.jboss.cache.factories.context.MVCCContextFactory;
import org.jboss.cache.invocation.InvocationContextContainer;
import org.jboss.cache.transaction.DummyTransactionManager;
import org.jboss.cache.util.TestingUtil;
import org.jboss.cache.util.concurrent.locks.LockContainer;
import org.testng.annotations.BeforeMethod;
import org.testng.annotations.Test;

import javax.transaction.TransactionManager;
import java.util.ArrayList;
import java.util.List;

/**
 * @author Manik Surtani (<a href="mailto:manik@jboss.org">manik@jboss.org</a>)
 * @since 3.0
 */
@Test(groups = {"unit", "mvcc"})
public class MVCCLockManagerRecordingTest extends AbstractLockManagerRecordingTest
{
   @BeforeMethod
   public void setUp()
   {
      icc = new InvocationContextContainer();
      MVCCLockManager mvccLockManager = new MVCCLockManager();
      TransactionManager tm = DummyTransactionManager.getInstance();
      mvccLockManager.injectConfiguration(new Configuration());
      mvccLockManager.injectDependencies(null, null, tm, icc);
      mvccLockManager.startLockManager();
      lm = mvccLockManager;
      contextFactory = new MVCCContextFactory();
      icc.injectContextFactory(contextFactory);
   }

   public void testFqnHashing()
   {
      LockContainer lc = (LockContainer) TestingUtil.extractField(lm, "lockContainer");
      List<Fqn> fqns = new ArrayList<Fqn>();
      fqns.add(Fqn.ROOT);
      fqns.add(Fqn.fromString("/1"));
      fqns.add(Fqn.fromString("/1/2"));
      fqns.add(Fqn.fromString("/1/2/3"));
      fqns.add(Fqn.fromString("/a/b/c/d"));

      for (Fqn f : fqns) System.out.println("Fqn: " + f + "; hash = " + lc.hashToIndex(f));
   }
}
